// C Source File
// Created 1/14/2001; 01:31:52 PM

#define RETURN_VALUE          // Return Pushed Expression

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

short _ti89;                  // Produce .89Z File

int key=0,SPRITE_HEIGHT=16,x1=1,x2=0,y1=1,y2=0;

static unsigned int tank[] =
  { 0x0000,0x0000,0x0000,0x0000,0x0000,0x07C0,0x0D60,0x1ABF,0x3560,0x7FFE,0x8889,0x5DDE,0x288C,0x1FF8,0x0000,0x0000};
  
static unsigned int home[] = 
  { 0xFFFF,0x8001,0x8421,0x8421,0x8421,0x8421,0x8421,0x87E1,0x8421,0x8421,0x8421,0x8421,0x8421,0x8421,0x8001,0xFFFF};

void intro(void) {
  clrscr ();
	DrawStr (1,1,"Press ESC to exit",A_NORMAL);
	DrawStr (1,9,"Press or Hold Buttons",A_NORMAL);
	DrawStr (1,17,"Up, Down, Left,",A_NORMAL);
	DrawStr (1,25,"or Right for movement.",A_NORMAL);
	DrawStr (1,35,"            _",A_NORMAL);
	DrawStr (1,43,"Get to the |H|",A_NORMAL);
	DrawStr (1,45,"            _",A_NORMAL);
	DrawStr (1,70,"Press Enter",A_NORMAL);
	ngetchx ();
}

inline void draw(int x1, int y1) {
	Sprite16(x1, y1, SPRITE_HEIGHT, tank, LCD_MEM, SPRT_XOR);
}

inline void erase(int x1, int y1) {
	Sprite16(x1, y1, SPRITE_HEIGHT, tank, LCD_MEM, SPRT_XOR);
}

void victory() {
if ((x1==x2) & (y1==y2)) {
		clrscr ();
		DrawStr (1,2,"Victory!",A_NORMAL);
		DrawStr (1,10,"You arrived at base.",A_NORMAL);
		DrawStr (1,18,"*Press ESC*",A_NORMAL);
		}
}

void moveUp(int *y1) {
	*y1-=1;

	if (*y1 < 1) {
		*y1=92;
	}

	if (*y1 > 92) {
		*y1=1;
	}
}

void moveDown(int *y1) {
	*y1+=1;

	if (*y1 < 1) {
		*y1=92;
	}

	if (*y1 > 92) {
		*y1=1;
	}
}

void moveLeft(int *x1) {
	*x1-=1;

	if (*x1 < 1) {
		*x1=152;
	}

	if (*x1 > 152) {
		*x1=1;
	}
}

void moveRight(int *x1) {
	*x1+=1;

	if (*x1 < 1) {
		*x1=152;
	}

	if (*x1 > 152) {
		*x1=1;
	}
}

void _main(void) {
  x2=random(144);
  y2=random(84);
	intro();

	clrscr();
	draw(x1,y1);
	Sprite16(x2, y2, SPRITE_HEIGHT, home, LCD_MEM, SPRT_XOR);
	while ((key = ngetchx()) != KEY_ESC) {
		victory();
		erase(x1,y1);

		if (key == KEY_UP) {
			moveUp(&y1);
		} else if (key == KEY_DOWN) {
			moveDown(&y1);
		} else if (key == KEY_LEFT) {
			moveLeft(&x1);
		} else if (key == KEY_RIGHT) {
			moveRight(&x1);
		} else if (key == KEY_UPRIGHT) {
			moveUp(&y1);
			moveRight(&x1);
		} else if (key == KEY_DOWNLEFT) {
			moveDown(&y1);
			moveLeft(&x1);
		}
	
		draw(x1,y1);
	}

	push_quantum(0xE9);
}
